<?php
namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\RelatoriosVistoriaService;
use FM\Traits\TResponse;

class RelatoriosVistoriaController extends FMCrud {

    use TResponse;

    protected $RelatoriosVistoriaService;

    public function __construct($crudService, $environment, RelatoriosVistoriaService $RelatoriosVistoriaService) {
            parent::__construct($crudService, $environment);
            $this->RelatoriosVistoriaService = $RelatoriosVistoriaService;
    }

    public function getFuncionarios(Request $request, Response $response) {
        try {
                $data = $this->RelatoriosVistoriaService->getFuncionarios();
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function getRelatoriosVistoria(Request $request, Response $response) {
        try {
                $data = $this->RelatoriosVistoriaService->getRelatoriosVistoria();
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function getCriteriosVistoria(Request $request, Response $response) {
        try {
                $data = $this->RelatoriosVistoriaService->getCriteriosVistoria($request->getParameters());
                $this->sendResponse($data, 200);
        } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFotosVistoria(Request $request, Response $response) {
        try {
                $data = $this->RelatoriosVistoriaService->getFotosVistoria($request->getParameters());
                $this->sendResponse($data, 200);
        } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFiltroVistoriaLocal(Request $request, Response $response) {
        try {
                $data = $this->RelatoriosVistoriaService->getFiltroVistoriaLocal();
                $this->sendResponse($data, 200);
        } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFiltroVistoriaChecklist(Request $request, Response $response) {
        try {
                $data = $this->RelatoriosVistoriaService->getFiltroVistoriaChecklist();
                $this->sendResponse($data, 200);
        } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFiltroVistoriaCliente(Request $request, Response $response) {
        try {
                $data = $this->RelatoriosVistoriaService->getFiltroVistoriaCliente();
                $this->sendResponse($data, 200);
        } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFiltroVistoriaSituacao(Request $request, Response $response) {
        try {
                $data = $this->RelatoriosVistoriaService->getFiltroVistoriaSituacao();
                $this->sendResponse($data, 200);
        } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

}
?>