<?php
namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use FM\Traits\TQuery;

class DashboardFactory {

    use TQuery;

    protected $connection;
    protected $entityManager;

    public function __construct(EntityManager $entityManager) {
      $this->connection = $entityManager->getConnection();
      $this->entityManager = $entityManager;
    }
    // requisição de retorno dos dados do dashboard Limpeza Finalizada
    public function getDadosLimpezaFinalizada($parametros) {

      $sql = "SELECT CA.NRCHECKLISTAGEND, CA.NRLOCALCLIENTE, CA.NRCHECKLIST, CA.NRFUNCIONARIO, CA.IDSITUACAOAGEND,
                TO_CHAR(CA.DTHORAAGEND, 'DD/MM/YYYY HH24:MI') DTHORAAGEND, LC.NMLOCALCLIENTE, LC.NRLOCALCLIENTEPAI AS LOCALPAI,
                LCP.NMLOCALCLIENTE AS NMLOCALPAI, TO_CHAR(CA.DTULTATU, 'DD/MM/YYYY HH24:MI')DTULTATU, GCHK.NRGERENCIAMENTOCHK, GCHK.IDSITUACAOGERCHK
                      FROM FCM_CHECKLISTAGEND CA
                      JOIN FCM_LOCALCLI LC
                      ON LC.NRLOCALCLIENTE = CA.NRLOCALCLIENTE
                      JOIN FCM_LOCALCLI LCP
                      ON LCP.NRLOCALCLIENTE = LC.NRLOCALCLIENTEPAI
                      JOIN FCM_CHECKLIST CHK
                      ON CA.NRCHECKLIST = CHK.NRCHECKLIST
                      JOIN FCM_FUNCIONARIO F
                      ON F.NRFUNCIONARIO = CA.NRFUNCIONARIO
                      JOIN FCM_GERENCIAMENTOCHK GCHK
                      ON GCHK.NRCHECKLISTAGEND = CA.NRCHECKLISTAGEND
                      WHERE CA.IDSITUACAOAGEND = '4'
                      AND GCHK.IDSITUACAOGERCHK = '1'
                      AND ((CA.NRFUNCIONARIO IN ( SELECT  A.NRFUNCIONARIO
                                                      FROM FCM_FUNCIONARIOSHIERARQ A
                                                          JOIN FCM_FUNCIONARIO B ON B.NRFUNCIONARIO = A.NRFUNCIONARIO
                                                          JOIN FCM_HIERARQUIAFUNC H ON H.NRHIERARQUIAFUNC = A.NRHIERARQUIAFUNC
                                                      WHERE A.NRHIERARQUIAFUNC = (SELECT NRHIERARQUIAFUNC
                                                                                  FROM FCM_HIERARQUIAFUNC
                                                                                      WHERE IDATIVO = 'S')
                                                      AND A.NRFUNCIONARIO IN (SELECT NRFUNCIONARIO
                                                                                          FROM FCM_FUNCIONARIOSHIERARQ
                                                                                      START WITH CDOPERADOR     = :CDOPERADOR
                                                                                      CONNECT BY PRIOR NRFUNCIONARIO = NRFUNCIONARIOPAI)))
                          OR (CA.CDOPERINCLUSAO = :CDOPERADOR))";

      return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);

    }

    public function getDadosTarefaAtrasada($parametros) {

      $sql = "SELECT  NRCHECKLISTAGEND, NRLOCALCLIENTE, NRCHECKLIST, NRFUNCIONARIO, IDSITUACAOAGEND, DTHORAAGEND, NMLOCALCLIENTE, LOCALPAI, NMLOCALPAI, HORAS AS DTHORAATRASO
               FROM ( SELECT CA.NRCHECKLISTAGEND, CA.NRLOCALCLIENTE, CA.NRCHECKLIST, CA.NRFUNCIONARIO, CA.IDSITUACAOAGEND,
                      TO_CHAR(CA.DTHORAAGEND, 'DD/MM/YYYY HH24:MI') DTHORAAGEND, LC.NMLOCALCLIENTE, LC.NRLOCALCLIENTEPAI AS LOCALPAI,
                      LCP.NMLOCALCLIENTE AS NMLOCALPAI, TRUNC(SYSDATE - CA.DTHORAAGEND) * 24 + TRUNC(((SYSDATE - CA.DTHORAAGEND) - TRUNC (SYSDATE - CA.DTHORAAGEND)) * 24) AS HORAS,
                      TRUNC(((((SYSDATE - CA.DTHORAAGEND) - TRUNC(SYSDATE - CA.DTHORAAGEND)) * 24) - TRUNC(((SYSDATE - CA.DTHORAAGEND) - TRUNC(SYSDATE - CA.DTHORAAGEND)) *24))*60) AS MINUTOS, CA.CDOPERINCLUSAO
                            FROM FCM_CHECKLISTAGEND CA
                            JOIN FCM_LOCALCLI LC
                            ON LC.NRLOCALCLIENTE = CA.NRLOCALCLIENTE
                            JOIN FCM_LOCALCLI LCP
                            ON LCP.NRLOCALCLIENTE = LC.NRLOCALCLIENTEPAI
                            JOIN FCM_CHECKLIST CHK
                            ON CA.NRCHECKLIST = CHK.NRCHECKLIST
                            JOIN FCM_FUNCIONARIO F
                            ON F.NRFUNCIONARIO = CA.NRFUNCIONARIO
                            WHERE ((IDSITUACAOAGEND = '5') OR ((IDSITUACAOAGEND = '1') AND (CA.DTHORAAGEND <= SYSDATE)))) TAREFASATRASADAS
               WHERE ((NRFUNCIONARIO IN (SELECT  A.NRFUNCIONARIO
                                                      FROM FCM_FUNCIONARIOSHIERARQ A
                                                          JOIN FCM_FUNCIONARIO B ON B.NRFUNCIONARIO = A.NRFUNCIONARIO
                                                          JOIN FCM_HIERARQUIAFUNC H ON H.NRHIERARQUIAFUNC = A.NRHIERARQUIAFUNC
                                                      WHERE A.NRHIERARQUIAFUNC = (SELECT NRHIERARQUIAFUNC
                                                                                  FROM FCM_HIERARQUIAFUNC
                                                                                      WHERE IDATIVO = 'S')
                                                      AND A.NRFUNCIONARIO IN (SELECT NRFUNCIONARIO
                                                                                          FROM FCM_FUNCIONARIOSHIERARQ
                                                                                      START WITH CDOPERADOR     = :CDOPERADOR
                                                                                      CONNECT BY PRIOR NRFUNCIONARIO = NRFUNCIONARIOPAI)))
                OR (CDOPERINCLUSAO = :CDOPERADOR))";

    return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);

  }

  public function getDadosTarefaConcluida($parametros) {

    $sql = "SELECT CA.NRCHECKLISTAGEND, CA.NRLOCALCLIENTE, CA.NRCHECKLIST, CA.NRFUNCIONARIO, CA.IDSITUACAOAGEND,
              TO_CHAR(CA.DTHORAAGEND, 'DD/MM/YYYY HH24:MI') DTHORAAGEND, LC.NMLOCALCLIENTE, LC.NRLOCALCLIENTEPAI AS LOCALPAI,
              LCP.NMLOCALCLIENTE AS NMLOCALPAI, TO_CHAR(CA.DTULTATU, 'DD/MM/YYYY HH24:MI') DTULTATU, GCHK.NRGERENCIAMENTOCHK, GCHK.IDSITUACAOGERCHK
                    FROM FCM_CHECKLISTAGEND CA
                    JOIN FCM_LOCALCLI LC
                    ON LC.NRLOCALCLIENTE = CA.NRLOCALCLIENTE
                    JOIN FCM_LOCALCLI LCP
                    ON LCP.NRLOCALCLIENTE = LC.NRLOCALCLIENTEPAI
                    JOIN FCM_CHECKLIST CHK
                    ON CA.NRCHECKLIST = CHK.NRCHECKLIST
                    JOIN FCM_FUNCIONARIO F
                    ON F.NRFUNCIONARIO = CA.NRFUNCIONARIO
                    JOIN FCM_GERENCIAMENTOCHK GCHK
                    ON GCHK.NRCHECKLISTAGEND = CA.NRCHECKLISTAGEND
                    WHERE CA.IDSITUACAOAGEND = '4'
                    AND GCHK.IDSITUACAOGERCHK = '3'
                    AND TRUNC(CA.DTHORAAGEND) BETWEEN TRUNC(SYSDATE-30) AND TRUNC(SYSDATE+30)
                    AND ((CA.NRFUNCIONARIO IN ( SELECT  A.NRFUNCIONARIO
                                                      FROM FCM_FUNCIONARIOSHIERARQ A
                                                          JOIN FCM_FUNCIONARIO B ON B.NRFUNCIONARIO = A.NRFUNCIONARIO
                                                          JOIN FCM_HIERARQUIAFUNC H ON H.NRHIERARQUIAFUNC = A.NRHIERARQUIAFUNC
                                                      WHERE A.NRHIERARQUIAFUNC = (SELECT NRHIERARQUIAFUNC
                                                                                  FROM FCM_HIERARQUIAFUNC
                                                                                      WHERE IDATIVO = 'S')
                                                      AND A.NRFUNCIONARIO IN (SELECT NRFUNCIONARIO
                                                                                          FROM FCM_FUNCIONARIOSHIERARQ
                                                                                      START WITH CDOPERADOR     = :CDOPERADOR
                                                                                      CONNECT BY PRIOR NRFUNCIONARIO = NRFUNCIONARIOPAI)))
                          OR (CA.CDOPERINCLUSAO = :CDOPERADOR))";

    return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);

  }

    public function countTarefasConcluidas($parametros) {
      $sql = "SELECT COUNT(CA.NRCHECKLISTAGEND) AS QTDTAREFASCONCLUIDAS
                  FROM FCM_CHECKLISTAGEND CA
                  JOIN FCM_LOCALCLI LC
                  ON LC.NRLOCALCLIENTE = CA.NRLOCALCLIENTE
                  JOIN FCM_LOCALCLI LCP
                  ON LCP.NRLOCALCLIENTE = LC.NRLOCALCLIENTEPAI
                  JOIN FCM_CHECKLIST CHK
                  ON CA.NRCHECKLIST = CHK.NRCHECKLIST
                  JOIN FCM_FUNCIONARIO F
                  ON F.NRFUNCIONARIO = CA.NRFUNCIONARIO
                  JOIN FCM_GERENCIAMENTOCHK GCHK
                  ON GCHK.NRCHECKLISTAGEND = CA.NRCHECKLISTAGEND
                  WHERE CA.IDSITUACAOAGEND = '4'
                  AND GCHK.IDSITUACAOGERCHK = '3'
                  AND TRUNC(SYSDATE) = TRUNC(CA.DTHORAAGEND)
                  AND ((CA.NRFUNCIONARIO IN ( SELECT  A.NRFUNCIONARIO
                                                      FROM FCM_FUNCIONARIOSHIERARQ A
                                                          JOIN FCM_FUNCIONARIO B ON B.NRFUNCIONARIO = A.NRFUNCIONARIO
                                                          JOIN FCM_HIERARQUIAFUNC H ON H.NRHIERARQUIAFUNC = A.NRHIERARQUIAFUNC
                                                      WHERE A.NRHIERARQUIAFUNC = (SELECT NRHIERARQUIAFUNC
                                                                                  FROM FCM_HIERARQUIAFUNC
                                                                                      WHERE IDATIVO = 'S')
                                                      AND A.NRFUNCIONARIO IN (SELECT NRFUNCIONARIO
                                                                                          FROM FCM_FUNCIONARIOSHIERARQ
                                                                                      START WITH CDOPERADOR     = :CDOPERADOR
                                                                                      CONNECT BY PRIOR NRFUNCIONARIO = NRFUNCIONARIOPAI)))
                          OR (CA.CDOPERINCLUSAO = :CDOPERADOR))";

      $std = $this->connection->prepare($sql);

      $std->execute($parametros);
      return $std->fetchAll();
    }

    public function countTarefas($parametros) {
      $sql = "SELECT COUNT(CA.NRCHECKLISTAGEND) AS QTDTAREFAS
                  FROM FCM_CHECKLISTAGEND CA
                  JOIN FCM_LOCALCLI LC
                  ON LC.NRLOCALCLIENTE = CA.NRLOCALCLIENTE
                  JOIN FCM_LOCALCLI LCP
                  ON LCP.NRLOCALCLIENTE = LC.NRLOCALCLIENTEPAI
                  JOIN FCM_CHECKLIST CHK
                  ON CA.NRCHECKLIST = CHK.NRCHECKLIST
                  JOIN FCM_FUNCIONARIO F
                  ON F.NRFUNCIONARIO = CA.NRFUNCIONARIO
                  WHERE TRUNC(SYSDATE) = TRUNC(DTHORAAGEND)
                  AND ((CA.NRFUNCIONARIO IN ( SELECT  A.NRFUNCIONARIO
                                                      FROM FCM_FUNCIONARIOSHIERARQ A
                                                          JOIN FCM_FUNCIONARIO B ON B.NRFUNCIONARIO = A.NRFUNCIONARIO
                                                          JOIN FCM_HIERARQUIAFUNC H ON H.NRHIERARQUIAFUNC = A.NRHIERARQUIAFUNC
                                                      WHERE A.NRHIERARQUIAFUNC = (SELECT NRHIERARQUIAFUNC
                                                                                  FROM FCM_HIERARQUIAFUNC
                                                                                      WHERE IDATIVO = 'S')
                                                      AND A.NRFUNCIONARIO IN (SELECT NRFUNCIONARIO
                                                                                          FROM FCM_FUNCIONARIOSHIERARQ
                                                                                      START WITH CDOPERADOR     = :CDOPERADOR
                                                                                      CONNECT BY PRIOR NRFUNCIONARIO = NRFUNCIONARIOPAI)))
                          OR (CA.CDOPERINCLUSAO = :CDOPERADOR))";

      $std = $this->connection->prepare($sql);

      $std->execute($parametros);
      return $std->fetchAll();
    }

    public function findLocal() {
      $sql = "SELECT * FROM FCM_LOCALCLI";

      return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    // requisição para retorno dos dados para o card (Ultimas Tarefas Realizadas) Dashboard Supervisor
    public function getDadosUltimasTarefas($parametros) {

      $sql = "SELECT ULTTAR.CODIGO, ULTTAR.NRLOCALCLIENTE, ULTTAR.NRCHECKLIST, ULTTAR.NRFUNCIONARIO, TRUNC(DTHORAAGEND) DTHORAAGEND,  TO_CHAR(ULTTAR.DTHORAAGEND, 'DD/MM/YYYY HH24:MI') AGENDADO, TRUNC(ULTTAR.DTULTATU) DTULTATU, TO_CHAR(ULTTAR.DTULTATU, 'DD/MM/YYYY HH24:MI') HORARIO, ULTTAR.NOME, ULTTAR.SITUACAO, ULTTAR.TIPO, FUNC.NMFUNCIONARIO, LC.NMLOCALCLIENTE, LC.NRLOCALCLIENTEPAI AS LOCALPAI, LCP.NMLOCALCLIENTE AS NMLOCALPAI,
                ULTTAR.IDSITUACAOGERCHK as STATUS
                FROM (SELECT NRGERENCIAMENTOCHK AS CODIGO, NRLOCALCLIENTE, NRCHECKLIST, DTHORAAGEND,
                            NRFUNCIONARIO, DTULTATU, 'Vistoria: '||NMGERENCIAMENTOCHK AS NOME , IDSITUACAOGERCHK AS SITUACAO,
                            'V' AS TIPO,
                            CASE IDSITUACAOGERCHK WHEN '1' THEN 'Aguardando vistoria'
                                  WHEN '2' THEN 'Vistoria em andamento'
                                  WHEN '3' THEN 'Tarefa Vistoriada'
                                  ELSE NULL END AS IDSITUACAOGERCHK
                        FROM FCM_GERENCIAMENTOCHK
                        WHERE IDSITUACAOGERCHK = '3'

                      UNION ALL

                      SELECT NRCHECKLISTAGEND AS CODIGO, NRLOCALCLIENTE, NRCHECKLIST, DTHORAAGEND,
                              NRFUNCIONARIO, DTULTATU, NMCHECKLISTAGEND AS NOME , IDSITUACAOAGEND AS SITUACAO,
                              'T' AS TIPO,
                              CASE IDSITUACAOAGEND WHEN '1' THEN 'Pendente'
                                  WHEN '2' THEN 'Tarefa em andamento'
                                  WHEN '3' THEN 'Tarefa Cancelada'
                                  WHEN '4' THEN 'Tarefa Concluída'
                                  WHEN '5' THEN 'Tarefa Atrasada'
                                  ELSE NULL END AS IDSITUACAOAGEND
                        FROM FCM_CHECKLISTAGEND
                        WHERE IDSITUACAOAGEND = '4'
                        ) ULTTAR
                JOIN FCM_FUNCIONARIO FUNC
                ON ULTTAR.NRFUNCIONARIO = FUNC.NRFUNCIONARIO
                JOIN FCM_LOCALCLI LC
                ON LC.NRLOCALCLIENTE = ULTTAR.NRLOCALCLIENTE
                JOIN FCM_LOCALCLI LCP
                ON LCP.NRLOCALCLIENTE = LC.NRLOCALCLIENTEPAI
            WHERE ULTTAR.NRFUNCIONARIO IN (SELECT  A.NRFUNCIONARIO
                                                      FROM FCM_FUNCIONARIOSHIERARQ A
                                                          JOIN FCM_FUNCIONARIO B ON B.NRFUNCIONARIO = A.NRFUNCIONARIO
                                                          JOIN FCM_HIERARQUIAFUNC H ON H.NRHIERARQUIAFUNC = A.NRHIERARQUIAFUNC
                                                      WHERE A.NRHIERARQUIAFUNC = (SELECT NRHIERARQUIAFUNC
                                                                                  FROM FCM_HIERARQUIAFUNC
                                                                                      WHERE IDATIVO = 'S')
                                                      AND A.NRFUNCIONARIO IN (SELECT NRFUNCIONARIO
                                                                                          FROM FCM_FUNCIONARIOSHIERARQ
                                                                                      START WITH CDOPERADOR     = :CDOPERADOR
                                                                                      CONNECT BY PRIOR NRFUNCIONARIO = NRFUNCIONARIOPAI))
            ORDER BY DTULTATU DESC ";
                  
          return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }

   // requisição para retorno dos dados para o card (Resumo de Tarefas) Dashboard Supervisor(Tarefas Diárias)
    public function getDadosResumoTarefas($parametros) {

      $sql = "SELECT ULTTAR.CODIGO, TRUNC(DTHORAAGEND) DTHORAAGEND,  TO_CHAR(ULTTAR.DTHORAAGEND, 'DD/MM/YYYY HH24:MI') AGENDADO,TRUNC(ULTTAR.DTULTATU) DTULTATU, TO_CHAR(ULTTAR.DTULTATU, 'DD/MM/YYYY HH24:MI') HORARIO, ULTTAR.NOME, LC.NMLOCALCLIENTE, LC.NRLOCALCLIENTEPAI AS LOCALPAI, LCP.NMLOCALCLIENTE AS NMLOCALPAI, 
                      ULTTAR.IDSITUACAOGERCHK as STATUS, ULTTAR.DIAS, ULTTAR.NRFUNCIONARIO, FUNC.NMFUNCIONARIO, ULTTAR.NRLOCALCLIENTE
                        FROM (SELECT NRGERENCIAMENTOCHK AS CODIGO, NRLOCALCLIENTE, NRCHECKLIST, DTHORAAGEND, NRFUNCIONARIO, DTULTATU, 'Vistoria: ' || NMGERENCIAMENTOCHK AS NOME, IDSITUACAOGERCHK AS SITUACAO, 'V' AS TIPO,
                              CASE IDSITUACAOGERCHK
                                WHEN '1' THEN 'Aguardando vistoria'
                                WHEN '2' THEN 'Vistoria em andamento'
                                WHEN '3' THEN 'Vistoria Realizada'
                                ELSE 'Tarefa Pendente' 
                              END AS IDSITUACAOGERCHK, 
                                TRUNC(SYSDATE - DTULTATU) AS DIAS
                              FROM FCM_GERENCIAMENTOCHK
                              WHERE ((DTHORAAGEND = SYSDATE) OR ((DTHORAAGEND < SYSDATE)))
                              
                            UNION ALL
                            
                            SELECT NRCHECKLISTAGEND AS CODIGO, NRLOCALCLIENTE, NRCHECKLIST, DTHORAAGEND, NRFUNCIONARIO, DTULTATU, NMCHECKLISTAGEND AS NOME, IDSITUACAOAGEND AS SITUACAO, 'T' AS TIPO,
                              CASE IDSITUACAOAGEND
                                WHEN '1' THEN 'Tarefa Pendente'
                                WHEN '2' THEN 'Tarefa em andamento'
                                WHEN '3' THEN 'Tarefa Cancelada'
                                WHEN '4' THEN 'Tarefa Concluída'
                                WHEN '5' THEN 'Tarefa Atrasada'
                                ELSE NULL END AS IDSITUACAOAGEND,
                                TRUNC(SYSDATE - DTULTATU) AS DIAS
                            FROM FCM_CHECKLISTAGEND
                            WHERE ((DTHORAAGEND = SYSDATE) OR ((DTHORAAGEND < SYSDATE)))) ULTTAR
                            
                      JOIN FCM_FUNCIONARIO FUNC ON ULTTAR.NRFUNCIONARIO = FUNC.NRFUNCIONARIO
                      JOIN FCM_LOCALCLI LC ON LC.NRLOCALCLIENTE = ULTTAR.NRLOCALCLIENTE
                      JOIN FCM_LOCALCLI LCP ON LCP.NRLOCALCLIENTE = LC.NRLOCALCLIENTEPAI
                WHERE ULTTAR.NRFUNCIONARIO IN (SELECT  A.NRFUNCIONARIO
                                                      FROM FCM_FUNCIONARIOSHIERARQ A
                                                          JOIN FCM_FUNCIONARIO B ON B.NRFUNCIONARIO = A.NRFUNCIONARIO
                                                          JOIN FCM_HIERARQUIAFUNC H ON H.NRHIERARQUIAFUNC = A.NRHIERARQUIAFUNC
                                                      WHERE A.NRHIERARQUIAFUNC = (SELECT NRHIERARQUIAFUNC
                                                                                  FROM FCM_HIERARQUIAFUNC
                                                                                      WHERE IDATIVO = 'S')
                                                      AND A.NRFUNCIONARIO IN (SELECT NRFUNCIONARIO
                                                                                          FROM FCM_FUNCIONARIOSHIERARQ
                                                                                      START WITH CDOPERADOR     = :CDOPERADOR
                                                                                      CONNECT BY PRIOR NRFUNCIONARIO = NRFUNCIONARIOPAI))
                ORDER BY DTULTATU DESC";

              return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }

    // requisição para retorno dos dados do grafico Tarefas Realizadas Dashboard Supervisor
    public function getDadosChartTarefas($parametros) {

        $sql = "SELECT A.NMATIVIDADE, COUNT(CA.NRCHECKLISTAGEND) AS QUANTIDADE, A.DSCORIDATIVIDADE
                  FROM FCM_CHECKLISTAGEND CA
                  JOIN FCM_LOCALCLI LC
                  ON LC.NRLOCALCLIENTE = CA.NRLOCALCLIENTE
                  JOIN FCM_TIPOLOCALCLI TC
                  ON TC.NRTIPOLOCALCLI = LC.NRTIPOLOCALCLI
                  JOIN FCM_ATIVIDADECHK ACHK
                  ON ACHK.NRCHECKLIST = CA.NRCHECKLIST
                  JOIN FCM_ATIVIDADE A
                  ON A.NRATIVIDADE = ACHK.NRATIVIDADE
                  WHERE TRUNC(CA.DTHORAAGEND) BETWEEN TRUNC(SYSDATE-30) AND TRUNC(SYSDATE+30)
                  AND IDSITUACAOAGEND = '4'
                  AND TC.IDTIPOLOCALCLI = '3'
                  AND ((CA.NRFUNCIONARIO IN (SELECT  A.NRFUNCIONARIO
                                                      FROM FCM_FUNCIONARIOSHIERARQ A
                                                          JOIN FCM_FUNCIONARIO B ON B.NRFUNCIONARIO = A.NRFUNCIONARIO
                                                          JOIN FCM_HIERARQUIAFUNC H ON H.NRHIERARQUIAFUNC = A.NRHIERARQUIAFUNC
                                                      WHERE A.NRHIERARQUIAFUNC = (SELECT NRHIERARQUIAFUNC
                                                                                  FROM FCM_HIERARQUIAFUNC
                                                                                      WHERE IDATIVO = 'S')
                                                      AND A.NRFUNCIONARIO IN (SELECT NRFUNCIONARIO
                                                                                          FROM FCM_FUNCIONARIOSHIERARQ
                                                                                      START WITH CDOPERADOR     = :CDOPERADOR
                                                                                      CONNECT BY PRIOR NRFUNCIONARIO = NRFUNCIONARIOPAI)))
                          OR (CA.CDOPERINCLUSAO = :CDOPERADOR))
                  GROUP BY A.NMATIVIDADE, A.DSCORIDATIVIDADE";

        $std = $this->connection->prepare($sql);

        $std->execute($parametros);
        return $std->fetchAll();
    }

     // requisição para retorno dos dados para o grafico Não Conformidades Dashboard Supervisor
    public function getDadosChartNaoConformidades($parametros) {

        $sql = "SELECT A.NMATIVIDADE, A.DSCORIDATIVIDADE, COUNT(C.NRCRITERIOTARGERCHK) AS QUANTIDADE
                        FROM FCM_CRITERIOTARGERCHK C
                        JOIN FCM_TAREFAGERCHK TG
                          ON TG.NRTAREFAGERCHK = C.NRTAREFAGERCHK
                        JOIN FCM_GERENCIAMENTOCHK GCHK
                          ON GCHK.NRGERENCIAMENTOCHK = TG.NRGERENCIAMENTOCHK
                        JOIN FCM_LOCALCLI LC
                          ON LC.NRLOCALCLIENTE = GCHK.NRLOCALCLIENTE
                        JOIN FCM_TIPOLOCALCLI TC
                          ON TC.NRTIPOLOCALCLI = LC.NRTIPOLOCALCLI
                        JOIN FCM_ATIVIDADECHK ACHK
                          ON ACHK.NRCHECKLIST = GCHK.NRCHECKLIST
                        JOIN FCM_ATIVIDADE A
                          ON A.NRATIVIDADE = ACHK.NRATIVIDADE
                       WHERE IDMARCADO = 'S'
                         AND TC.IDTIPOLOCALCLI = '3'
                         AND TRUNC(GCHK.DTHORAAGEND) BETWEEN TRUNC(SYSDATE-30) AND TRUNC(SYSDATE+30)
                         AND TG.NRFUNCIONARIO IN (SELECT  A.NRFUNCIONARIO
                                                      FROM FCM_FUNCIONARIOSHIERARQ A
                                                          JOIN FCM_FUNCIONARIO B ON B.NRFUNCIONARIO = A.NRFUNCIONARIO
                                                          JOIN FCM_HIERARQUIAFUNC H ON H.NRHIERARQUIAFUNC = A.NRHIERARQUIAFUNC
                                                      WHERE A.NRHIERARQUIAFUNC = (SELECT NRHIERARQUIAFUNC
                                                                                  FROM FCM_HIERARQUIAFUNC
                                                                                      WHERE IDATIVO = 'S')
                                                      AND A.NRFUNCIONARIO IN (SELECT NRFUNCIONARIO
                                                                                          FROM FCM_FUNCIONARIOSHIERARQ
                                                                                      START WITH CDOPERADOR     = :CDOPERADOR
                                                                                      CONNECT BY PRIOR NRFUNCIONARIO = NRFUNCIONARIOPAI))
                    GROUP BY A.NMATIVIDADE, A.DSCORIDATIVIDADE
                    ORDER BY QUANTIDADE ASC";

        $std = $this->connection->prepare($sql);

        $std->execute($parametros);
        return $std->fetchAll();
    }

   // requisição para retorno dos dados para grafico Progresso Diario Dashboard Supervisor(Tarefas Diárias)
    public function countTarefasConcluidasDia($parametros) {

        $sql = "SELECT QUANTIDADE_CONCLUIDAS.NMATIVIDADE, QUANTIDADE_CONCLUIDAS.QUANTIDADE, QUANTIDADE_CONCLUIDAS.DSCORIDATIVIDADE,
                       ROUND((QUANTIDADE_CONCLUIDAS.QUANTIDADE * 100 / QUANTIDADE_TOTAL.QUANTIDADE_TOTAL),2 )AS PORCENTAGEM

                    FROM (SELECT AT.NMATIVIDADE, AT.NRATIVIDADE, AT.DSCORIDATIVIDADE,
                                 COUNT(CA.NRCHECKLISTAGEND) AS QUANTIDADE
                             FROM FCM_CHECKLISTAGEND CA
                             JOIN FCM_ATIVIDADECHK AC
                               ON AC.NRCHECKLIST = CA.NRCHECKLIST
                             JOIN FCM_ATIVIDADE AT
                               ON AT.NRATIVIDADE = AC.NRATIVIDADE
                               WHERE TRUNC(CA.DTHORAAGEND) BETWEEN TRUNC(SYSDATE-30) AND TRUNC(SYSDATE+30)
                              AND CA.IDSITUACAOAGEND = '4'
                              AND ((CA.NRFUNCIONARIO IN (SELECT  A.NRFUNCIONARIO
                                                      FROM FCM_FUNCIONARIOSHIERARQ A
                                                          JOIN FCM_FUNCIONARIO B ON B.NRFUNCIONARIO = A.NRFUNCIONARIO
                                                          JOIN FCM_HIERARQUIAFUNC H ON H.NRHIERARQUIAFUNC = A.NRHIERARQUIAFUNC
                                                      WHERE A.NRHIERARQUIAFUNC = (SELECT NRHIERARQUIAFUNC
                                                                                  FROM FCM_HIERARQUIAFUNC
                                                                                      WHERE IDATIVO = 'S')
                                                      AND A.NRFUNCIONARIO IN (SELECT NRFUNCIONARIO
                                                                                          FROM FCM_FUNCIONARIOSHIERARQ
                                                                                      START WITH CDOPERADOR     = :CDOPERADOR
                                                                                      CONNECT BY PRIOR NRFUNCIONARIO = NRFUNCIONARIOPAI)))
                          OR (CA.CDOPERINCLUSAO = :CDOPERADOR))
                           GROUP BY AT.NMATIVIDADE, AT.NRATIVIDADE, AT.DSCORIDATIVIDADE) QUANTIDADE_CONCLUIDAS,

                          (SELECT AT.NMATIVIDADE, AT.NRATIVIDADE, COUNT(CA.NRCHECKLISTAGEND) AS QUANTIDADE_TOTAL
                             FROM FCM_CHECKLISTAGEND CA
                             JOIN FCM_ATIVIDADECHK AC
                               ON AC.NRCHECKLIST = CA.NRCHECKLIST
                             JOIN FCM_ATIVIDADE AT
                               ON AT.NRATIVIDADE = AC.NRATIVIDADE
                               WHERE TRUNC(CA.DTHORAAGEND) BETWEEN TRUNC(SYSDATE-30) AND TRUNC(SYSDATE+30)
                              AND ((CA.NRFUNCIONARIO IN (SELECT  A.NRFUNCIONARIO
                                                      FROM FCM_FUNCIONARIOSHIERARQ A
                                                          JOIN FCM_FUNCIONARIO B ON B.NRFUNCIONARIO = A.NRFUNCIONARIO
                                                          JOIN FCM_HIERARQUIAFUNC H ON H.NRHIERARQUIAFUNC = A.NRHIERARQUIAFUNC
                                                      WHERE A.NRHIERARQUIAFUNC = (SELECT NRHIERARQUIAFUNC
                                                                                  FROM FCM_HIERARQUIAFUNC
                                                                                      WHERE IDATIVO = 'S')
                                                      AND A.NRFUNCIONARIO IN (SELECT NRFUNCIONARIO
                                                                                          FROM FCM_FUNCIONARIOSHIERARQ
                                                                                      START WITH CDOPERADOR     = :CDOPERADOR
                                                                                      CONNECT BY PRIOR NRFUNCIONARIO = NRFUNCIONARIOPAI)))
                          OR (CA.CDOPERINCLUSAO = :CDOPERADOR))
                         GROUP BY  AT.NMATIVIDADE, AT.NRATIVIDADE) QUANTIDADE_TOTAL
                    WHERE QUANTIDADE_TOTAL.NRATIVIDADE = QUANTIDADE_CONCLUIDAS.NRATIVIDADE";

        $std = $this->connection->prepare($sql);

        $std->execute($parametros);
        return $std->fetchAll();
    }

  // ------ REQUISIÇÕES DA TELA DE DASHBOARD (GERENCIAL) ----------

    public function setActivities() {

      $sql = "SELECT NRATIVIDADE, NMATIVIDADE
                FROM FCM_ATIVIDADE";

      $std = $this->connection->prepare($sql);

      $std->execute();
      return $std->fetchAll();
    }

    public function getLocals($id) {

      $sql = "SELECT FCM_LOCALCLI.NRLOCALCLIENTE, FCM_LOCALCLI.NMLOCALCLIENTE,
                           FCM_LOCALCLI.NRSETOR, FCM_LOCALCLI.NRLOCALCLIENTEPAI, FCM_TIPOLOCALCLI.NRTIPOLOCALCLI
                     FROM FCM_LOCALCLI
                     JOIN FCM_TIPOLOCALCLI
                       ON FCM_LOCALCLI.NRTIPOLOCALCLI = FCM_TIPOLOCALCLI.NRTIPOLOCALCLI
                        WHERE FCM_TIPOLOCALCLI.IDTIPOLOCALCLI = :ID";


      $std = $this->connection->prepare($sql);

      $std->execute($id);
      return $std->fetchAll();
    }

    public function dataBaseChartBarUnconformities($param, $paramAct) {

        $sql = "SELECT COUNT(C.NRCRITERIOTARGERCHK) AS QUANTIDADE, AT.NMATIVIDADE, AT.DSCORIDATIVIDADE
                 FROM FCM_CRITERIOTARGERCHK C
                 JOIN FCM_TAREFAGERCHK TG
                   ON TG.NRTAREFAGERCHK = C.NRTAREFAGERCHK
                 JOIN FCM_GERENCIAMENTOCHK GCHK
                   ON GCHK.NRGERENCIAMENTOCHK = TG.NRGERENCIAMENTOCHK
                 JOIN FCM_ATIVIDADECHK ACK
                   ON ACK.NRCHECKLIST = GCHK.NRCHECKLIST
                 JOIN FCM_ATIVIDADE AT
                   ON AT.NRATIVIDADE = ACK.NRATIVIDADE
                 JOIN FCM_LOCALCLI LC
                   ON LC.NRLOCALCLIENTE = GCHK.NRLOCALCLIENTE
                 JOIN (SELECT LCPAI.NRLOCALCLIENTE, LCPAI.NRLOCALCLIENTEPAI
                          FROM FCM_LOCALCLI LCPAI
                          JOIN FCM_TIPOLOCALCLI TPL
                            ON TPL.NRTIPOLOCALCLI = LCPAI.NRTIPOLOCALCLI
                         WHERE TPL.IDTIPOLOCALCLI = 2) LCPAI
                   ON LC.NRLOCALCLIENTEPAI = LCPAI.NRLOCALCLIENTE
                 JOIN FCM_LOCALCLI NMPAI
                   ON NMPAI.NRLOCALCLIENTE = LCPAI.NRLOCALCLIENTEPAI
                 JOIN FCM_TIPOLOCALCLI TC
                   ON TC.NRTIPOLOCALCLI = LC.NRTIPOLOCALCLI
                 JOIN (SELECT C.NRCHECKLIST
                          FROM FCM_CHECKLIST C
                          JOIN FCM_ATIVIDADECHK AC
                            ON AC.NRCHECKLIST = C.NRCHECKLIST".$paramAct."
                         GROUP BY C.NRCHECKLIST) ATIVIDADES
                   ON ATIVIDADES.NRCHECKLIST = GCHK.NRCHECKLIST
                WHERE IDMARCADO = 'S'
                  AND TC.IDTIPOLOCALCLI = '3'
                  AND TRUNC(SYSDATE) = TRUNC(DTHORAAGEND)".$param."
             GROUP BY AT.NMATIVIDADE, AT.DSCORIDATIVIDADE
             ORDER BY QUANTIDADE ASC";

        $std = $this->connection->prepare($sql);

        $std->execute();
        return $std->fetchAll();

    }

    // Requisição para o segundo gráfico, de tarefas. O título foi mudado após a requisição estar feita
    public function dataBaseChartPieClean($param, $paramAct) {

        $sql = "SELECT AT.NMATIVIDADE, AT.DSCORIDATIVIDADE, COUNT(CA.NRCHECKLISTAGEND) AS QUANTIDADE
                        FROM FCM_CHECKLISTAGEND CA
                        JOIN FCM_ATIVIDADECHK ATC
                          ON CA.NRCHECKLIST = ATC.NRCHECKLIST
                        JOIN FCM_ATIVIDADE AT
                          ON AT.NRATIVIDADE = ATC.NRATIVIDADE
                        JOIN FCM_LOCALCLI LC
                          ON LC.NRLOCALCLIENTE = CA.NRLOCALCLIENTE
                        JOIN (SELECT LCPAI.NRLOCALCLIENTE, LCPAI.NRLOCALCLIENTEPAI
                                FROM FCM_LOCALCLI LCPAI
                                JOIN FCM_TIPOLOCALCLI TPL
                                  ON TPL.NRTIPOLOCALCLI = LCPAI.NRTIPOLOCALCLI
                               WHERE TPL.IDTIPOLOCALCLI = 2) LCPAI
                          ON LC.NRLOCALCLIENTEPAI = LCPAI.NRLOCALCLIENTE
                        JOIN FCM_LOCALCLI NMPAI
                          ON NMPAI.NRLOCALCLIENTE = LCPAI.NRLOCALCLIENTEPAI
                        JOIN FCM_TIPOLOCALCLI TC
                          ON TC.NRTIPOLOCALCLI = LC.NRTIPOLOCALCLI
                        JOIN (SELECT C.NRCHECKLIST
                                FROM FCM_CHECKLIST C
                                JOIN FCM_ATIVIDADECHK AC
                                  ON AC.NRCHECKLIST = C.NRCHECKLIST".$paramAct."
                               GROUP BY C.NRCHECKLIST) ATIVIDADES
                         ON ATIVIDADES.NRCHECKLIST = CA.NRCHECKLIST
                      WHERE TRUNC(SYSDATE) = TRUNC(DTHORAAGEND)
                        AND IDSITUACAOAGEND = '4'
                        AND TC.IDTIPOLOCALCLI = '3'".$param."
                   GROUP BY AT.NMATIVIDADE, AT.DSCORIDATIVIDADE";

        $std = $this->connection->prepare($sql);

        $std->execute();
        return $std->fetchAll();

    }

    public function dataBaseChartPieUnit($param, $paramAct) {

        $sql = "SELECT  LCPAI.NRLOCALCLIENTEPAI, NMPAI.NMLOCALCLIENTE, COUNT(CA.NRCHECKLISTAGEND) QUANTIDADE, NMPAI.DSCORIDLOCAL
                  FROM FCM_CHECKLISTAGEND CA
                  JOIN FCM_LOCALCLI
                    ON FCM_LOCALCLI.NRLOCALCLIENTE = CA.NRLOCALCLIENTE
                  JOIN (SELECT LCPAI.NRLOCALCLIENTE, LCPAI.NRLOCALCLIENTEPAI
                          FROM FCM_LOCALCLI LCPAI
                          JOIN FCM_TIPOLOCALCLI TPL
                            ON TPL.NRTIPOLOCALCLI = LCPAI.NRTIPOLOCALCLI
                         WHERE TPL.IDTIPOLOCALCLI = 2) LCPAI
                    ON FCM_LOCALCLI.NRLOCALCLIENTEPAI = LCPAI.NRLOCALCLIENTE
                  JOIN FCM_LOCALCLI NMPAI
                    ON NMPAI.NRLOCALCLIENTE = LCPAI.NRLOCALCLIENTEPAI
                  JOIN (SELECT C.NRCHECKLIST
                          FROM FCM_CHECKLIST C
                          JOIN FCM_ATIVIDADECHK AC
                            ON AC.NRCHECKLIST = C.NRCHECKLIST".$paramAct."
                         GROUP BY C.NRCHECKLIST) ATIVIDADES
                    ON ATIVIDADES.NRCHECKLIST = CA.NRCHECKLIST
                 WHERE TRUNC(SYSDATE) = TRUNC(DTHORAAGEND)
                   AND IDSITUACAOAGEND = '4'".$param."
                 GROUP BY LCPAI.NRLOCALCLIENTEPAI, NMPAI.NMLOCALCLIENTE, NMPAI.DSCORIDLOCAL";

        $std = $this->connection->prepare($sql);

        $std->execute();
        return $std->fetchAll();

    }

    public function dataBaseChartBarAvgTime($param, $paramAct) {

        $sql = "SELECT A.NMATIVIDADE, A.NRATIVIDADE, ROUND (AVG(MINTAREFAS)) TEMPOMEDIOTAREFAS, A.DSCORIDATIVIDADE
                  FROM FCM_ATIVIDADE A
                  JOIN (SELECT A.NRATIVIDADE, A.NMATIVIDADE, AC.NRCHECKLIST, CA.DTHRFINALAGEND, CA.DTHORAAGEND, ROUND((((CA.DTHRFINALAGEND - CA.DTHORAAGEND) * 24) * 60), 2) MINTAREFAS
                          FROM FCM_ATIVIDADE A
                          JOIN FCM_ATIVIDADECHK AC
                            ON AC.NRATIVIDADE = A.NRATIVIDADE
                          JOIN FCM_CHECKLISTAGEND CA
                            ON CA.NRCHECKLIST = AC.NRCHECKLIST
                          JOIN FCM_LOCALCLI LC
                            ON LC.NRLOCALCLIENTE = CA.NRLOCALCLIENTE
                          JOIN (SELECT LCPAI.NRLOCALCLIENTE, LCPAI.NRLOCALCLIENTEPAI
                                                FROM FCM_LOCALCLI LCPAI
                                                JOIN FCM_TIPOLOCALCLI TPL
                                                  ON TPL.NRTIPOLOCALCLI = LCPAI.NRTIPOLOCALCLI
                                               WHERE TPL.IDTIPOLOCALCLI = 2) LCPAI
                            ON LC.NRLOCALCLIENTEPAI = LCPAI.NRLOCALCLIENTE
                          JOIN (SELECT C.NRCHECKLIST
                                     FROM FCM_CHECKLIST C
                                     JOIN FCM_ATIVIDADECHK AC
                                       ON AC.NRCHECKLIST = C.NRCHECKLIST".$paramAct."
                                 GROUP BY C.NRCHECKLIST) ATIVIDADES
                            ON ATIVIDADES.NRCHECKLIST = CA.NRCHECKLIST
                         WHERE CA.IDSITUACAOAGEND = '4' 
                         AND TRUNC(SYSDATE) = TRUNC(DTHORAAGEND)".$param.") TEMPOTAREFAS
                    ON TEMPOTAREFAS.NRATIVIDADE = A.NRATIVIDADE
              GROUP BY A.NRATIVIDADE, A.NMATIVIDADE, A.DSCORIDATIVIDADE";

        $std = $this->connection->prepare($sql);

        $std->execute();
        return $std->fetchAll();

    }

    public function latestReports() {

      $sql = "SELECT RE.NRRELATORIOS, RE.NMRELATORIOS, RE.NRFONTEDADOSGRAFREL, RE.NRFUNCRESPONSAVEL, F.NMFUNCIONARIO,
              FDGR.NMFONTEDADOSGRAFREL, TO_CHAR(RE.DTINIRELATORIO, 'DD/MM/YY') || ' - ' || TO_CHAR(RE.DTFIMRELATORIO, 'DD/MM/YY') AS DTRELATORIO
                FROM FCM_RELATORIOS RE
                JOIN FCM_FUNCIONARIO F
                ON F.NRFUNCIONARIO = RE.NRFUNCRESPONSAVEL
                JOIN FCM_FONTEDADOSGRAFREL FDGR
                ON FDGR.NRFONTEDADOSGRAFREL = RE.NRFONTEDADOSGRAFREL";

      $std = $this->connection->prepare($sql);

      $std->execute();
      return $std->fetchAll();

    }
    
    public function percentageTasksCompleted ($usersIds) {
      $sql = "SELECT COUNT(CA.NRCHECKLISTAGEND) AS QTDTAREFASCONCLUIDAS
                FROM FCM_CHECKLISTAGEND CA
                JOIN FCM_LOCALCLI LC
                ON LC.NRLOCALCLIENTE = CA.NRLOCALCLIENTE
                JOIN FCM_LOCALCLI LCP
                ON LCP.NRLOCALCLIENTE = LC.NRLOCALCLIENTEPAI
                JOIN FCM_CHECKLIST CHK
                ON CA.NRCHECKLIST = CHK.NRCHECKLIST
                JOIN FCM_FUNCIONARIO F
                ON F.NRFUNCIONARIO = CA.NRFUNCIONARIO
                JOIN FCM_GERENCIAMENTOCHK GCHK
                ON GCHK.NRCHECKLISTAGEND = CA.NRCHECKLISTAGEND
                WHERE CA.IDSITUACAOAGEND = '4'
                AND GCHK.IDSITUACAOGERCHK = '3'
                AND TRUNC(SYSDATE) = TRUNC(CA.DTHORAAGEND)
                AND CA.NRFUNCIONARIO IN ({$usersIds})";

      $std = $this->connection->prepare($sql);

      $std->execute();
      return $std->fetchAll();
    }

    public function percentageAllTasks ($usersIds) {
      $sql = "SELECT COUNT(CA.NRCHECKLISTAGEND) AS QTDTAREFAS
                FROM FCM_CHECKLISTAGEND CA
                JOIN FCM_LOCALCLI LC
                ON LC.NRLOCALCLIENTE = CA.NRLOCALCLIENTE
                JOIN FCM_LOCALCLI LCP
                ON LCP.NRLOCALCLIENTE = LC.NRLOCALCLIENTEPAI
                JOIN FCM_CHECKLIST CHK
                ON CA.NRCHECKLIST = CHK.NRCHECKLIST
                JOIN FCM_FUNCIONARIO F
                ON F.NRFUNCIONARIO = CA.NRFUNCIONARIO
                WHERE TRUNC(SYSDATE) = TRUNC(DTHORAAGEND)
                AND CA.NRFUNCIONARIO IN ({$usersIds})";

      $std = $this->connection->prepare($sql);

      $std->execute();
      return $std->fetchAll();
    }
    
    public function tasksCompleted($usersIds) {

        $sql = "SELECT CA.NRCHECKLISTAGEND, CA.NRLOCALCLIENTE, CA.NRCHECKLIST, CA.NRFUNCIONARIO, CA.IDSITUACAOAGEND, CA.NMCHECKLISTAGEND,
                  TO_CHAR(CA.DTHORAAGEND, 'DD/MM HH24:MI') DTHORAAGEND, LC.NMLOCALCLIENTE, LC.NRLOCALCLIENTEPAI AS LOCALPAI,
                  LCP.NMLOCALCLIENTE AS NMLOCALPAI, TO_CHAR(CA.DTULTATU, 'DD/MM HH24:MI')DTULTATU, GCHK.NRGERENCIAMENTOCHK, GCHK.IDSITUACAOGERCHK, F.NMFUNCIONARIO
                        FROM FCM_CHECKLISTAGEND CA
                        JOIN FCM_LOCALCLI LC
                        ON LC.NRLOCALCLIENTE = CA.NRLOCALCLIENTE
                        JOIN FCM_LOCALCLI LCP
                        ON LCP.NRLOCALCLIENTE = LC.NRLOCALCLIENTEPAI
                        JOIN FCM_CHECKLIST CHK
                        ON CA.NRCHECKLIST = CHK.NRCHECKLIST
                        JOIN FCM_FUNCIONARIO F
                        ON F.NRFUNCIONARIO = CA.NRFUNCIONARIO
                        JOIN FCM_GERENCIAMENTOCHK GCHK
                        ON GCHK.NRCHECKLISTAGEND = CA.NRCHECKLISTAGEND
                        WHERE CA.IDSITUACAOAGEND = '4'
                        AND GCHK.IDSITUACAOGERCHK = '3'
                        AND F.NRFUNCIONARIO IN ({$usersIds})
                        AND TRUNC(SYSDATE) = TRUNC(CA.DTHORAAGEND)";

        $std = $this->connection->prepare($sql);

        $std->execute();
        return $std->fetchAll();
    }
    
    public function tasksLate($usersIds) {

      $sql = "SELECT  NRCHECKLISTAGEND, NRLOCALCLIENTE, NRCHECKLIST, NRFUNCIONARIO, IDSITUACAOAGEND, DTHORAAGEND, NMLOCALCLIENTE, LOCALPAI, NMLOCALPAI, HORAS AS DTHORAATRASO, NMFUNCIONARIO, NMCHECKLISTAGEND
               FROM ( SELECT CA.NRCHECKLISTAGEND, CA.NRLOCALCLIENTE, CA.NRCHECKLIST, CA.NRFUNCIONARIO, CA.IDSITUACAOAGEND,CA.NMCHECKLISTAGEND,
                      TO_CHAR(CA.DTHORAAGEND, 'DD/MM HH24:MI') DTHORAAGEND, LC.NMLOCALCLIENTE, LC.NRLOCALCLIENTEPAI AS LOCALPAI, F.NMFUNCIONARIO,
                      LCP.NMLOCALCLIENTE AS NMLOCALPAI, TRUNC(SYSDATE - CA.DTHORAAGEND) * 24 + TRUNC(((SYSDATE - CA.DTHORAAGEND) - TRUNC (SYSDATE - CA.DTHORAAGEND)) * 24) AS HORAS,
                      TRUNC(((((SYSDATE - CA.DTHORAAGEND) - TRUNC(SYSDATE - CA.DTHORAAGEND)) * 24) - TRUNC(((SYSDATE - CA.DTHORAAGEND) - TRUNC(SYSDATE - CA.DTHORAAGEND)) *24))*60) AS MINUTOS
                            FROM FCM_CHECKLISTAGEND CA
                            JOIN FCM_LOCALCLI LC
                            ON LC.NRLOCALCLIENTE = CA.NRLOCALCLIENTE
                            JOIN FCM_LOCALCLI LCP
                            ON LCP.NRLOCALCLIENTE = LC.NRLOCALCLIENTEPAI
                            JOIN FCM_CHECKLIST CHK
                            ON CA.NRCHECKLIST = CHK.NRCHECKLIST
                            JOIN FCM_FUNCIONARIO F
                            ON F.NRFUNCIONARIO = CA.NRFUNCIONARIO
                            WHERE IDSITUACAOAGEND = '5'
                            AND F.NRFUNCIONARIO IN ({$usersIds})) TAREFASATRASADAS";

      $std = $this->connection->prepare($sql);

      $std->execute();
      return $std->fetchAll();
    }
    
    public function lastTasksPerformed($usersIds) {

        $sql = "SELECT ULTTAR.CODIGO, ULTTAR.NRLOCALCLIENTE, ULTTAR.NRCHECKLIST, ULTTAR.NRFUNCIONARIO, TO_CHAR(ULTTAR.DTULTATU, 'DD/MM HH24:MI') DTULTATU, ULTTAR.NOME, ULTTAR.SITUACAO, ULTTAR.TIPO, FUNC.NMFUNCIONARIO, LC.NMLOCALCLIENTE, LC.NRLOCALCLIENTEPAI AS LOCALPAI, LCP.NMLOCALCLIENTE AS NMLOCALPAI
                FROM (SELECT NRGERENCIAMENTOCHK AS CODIGO, NRLOCALCLIENTE, NRCHECKLIST,
                             NRFUNCIONARIO, DTULTATU, 'Vistoria: '||NMGERENCIAMENTOCHK AS NOME , IDSITUACAOGERCHK AS SITUACAO,
                             'V' AS TIPO
                        FROM FCM_GERENCIAMENTOCHK
                       WHERE IDSITUACAOGERCHK = '3'

                       UNION ALL

                       SELECT NRCHECKLISTAGEND AS CODIGO, NRLOCALCLIENTE, NRCHECKLIST,
                              NRFUNCIONARIO, DTULTATU, NMCHECKLISTAGEND AS NOME , IDSITUACAOAGEND AS SITUACAO,
                              'T' AS TIPO
                         FROM FCM_CHECKLISTAGEND
                        WHERE IDSITUACAOAGEND = '4'
                        ) ULTTAR
                JOIN FCM_FUNCIONARIO FUNC
                ON ULTTAR.NRFUNCIONARIO = FUNC.NRFUNCIONARIO
                JOIN FCM_LOCALCLI LC
                ON LC.NRLOCALCLIENTE = ULTTAR.NRLOCALCLIENTE
                JOIN FCM_LOCALCLI LCP
                ON LCP.NRLOCALCLIENTE = LC.NRLOCALCLIENTEPAI
                WHERE ULTTAR.NRFUNCIONARIO IN ({$usersIds})
                AND ULTTAR.DTULTATU BETWEEN SYSDATE - 7 AND SYSDATE
                ORDER BY DTULTATU DESC";

        $std = $this->connection->prepare($sql);

        $std->execute();
        return $std->fetchAll();
    }
    
    public function dataBaseChartPie($usersIds) {

        $sql = "SELECT AT.NMATIVIDADE, COUNT(CA.NRCHECKLISTAGEND) AS QUANTIDADE, AT.DSCORIDATIVIDADE
                      FROM FCM_CHECKLISTAGEND CA
                      JOIN FCM_ATIVIDADECHK AC
                        ON AC.NRCHECKLIST = CA.NRCHECKLIST
                      JOIN FCM_ATIVIDADE AT
                        ON AT.NRATIVIDADE = AC.NRATIVIDADE
                     WHERE TRUNC(SYSDATE) = TRUNC(DTHORAAGEND)
                       AND IDSITUACAOAGEND = '4'
                       AND CA.NRFUNCIONARIO IN ({$usersIds})
                  GROUP BY AT.NMATIVIDADE, AT.DSCORIDATIVIDADE";

        $std = $this->connection->prepare($sql);

        $std->execute();
        return $std->fetchAll();

    }
    
    public function dataBaseChartBar($usersIds) {

        $sql = "SELECT AT.NMATIVIDADE, COUNT(C.NRCRITERIOTARGERCHK) AS QUANTIDADE, AT.DSCORIDATIVIDADE
                  FROM FCM_CRITERIOTARGERCHK C
                  JOIN FCM_TAREFAGERCHK TG
                  ON TG.NRTAREFAGERCHK = C.NRTAREFAGERCHK
                  JOIN FCM_GERENCIAMENTOCHK GCHK
                  ON GCHK.NRGERENCIAMENTOCHK = TG.NRGERENCIAMENTOCHK
                  JOIN FCM_ATIVIDADECHK AC
                  ON AC.NRCHECKLIST = GCHK.NRCHECKLIST
                  JOIN FCM_ATIVIDADE AT
                  ON AT.NRATIVIDADE = AC.NRATIVIDADE
                  WHERE IDMARCADO = 'S'
                  AND TRUNC(SYSDATE) = TRUNC(DTHORAAGEND)
                  AND GCHK.NRFUNCIONARIO IN ({$usersIds})
                  GROUP BY AT.NMATIVIDADE, AT.DSCORIDATIVIDADE
                  ORDER BY QUANTIDADE ASC";

        $std = $this->connection->prepare($sql);

        $std->execute();
        return $std->fetchAll();

    }
}